
'''
    Created on Apr 1, 2013
    ### TODO LIST
    
    ### Install LXML and FITS
    ###
    @author: Siva
    # Copyright 2013 The University of Texas at Austin
    #
    #   Licensed under the Apache License, Version 2.0 (the "License");
    #   you may not use this file except in compliance with the License.
    #   You may obtain a copy of the License at
    
    #       http://www.apache.org/licenses/LICENSE-2.0
    
    #   Unless required by applicable law or agreed to in writing, software
    #   distributed under the License is distributed on an "AS IS" BASIS,
    #   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    #   See the License for the specific language governing permissions and
    #   limitations under the License.
    #
    '''
from lxml import etree
import os, shlex, subprocess
import re
import string
import commands
import sys
import time
import ConfigParser
import smtplib
#from email.mime.text import MIMEText
import traceback
import shutil

#Configuration Strings

#Provide default resource
IRODS_DEFAULT_RESOURCE="gpfs-repl"
UNIX_DELIMITER = "/"
pizzica = "pz"

#Provide path for xpath stuff for nesting DC elements
xpath = "//mets:dmdSec/mets:mdWrap/mets:xmlData"
xpath2 = "//mets:dmdSec/mets:mdWrap/mets:xmlData/dcterms:coverage"
xpath3 = "//mets:dmdSec/mets:mdWrap/mets:xmlData/dcterms:relation"
xpath1 = "/mets:mets/mets:amdSec/mets:digiprovMD/mets:mdWrap/mets:xmlData/premis/premis:objectIdentifier"

#Provide stylesheet path
stylesheetpath="/corral-repl/tacc/dmc/siva/ICA/test.xsl"

#Provide iRODS server Path
SERVER_URL="http://icat.corral.tacc.utexas.edu:1247"
DELIMITER = "/"


#Irods Icommand Path
IRODS_ICOMMAND_PATH = "/corral-repl/tacc/dmc/siva/iRODS/clients/icommands/bin"

#Directory to use for temporary creation of files on the same resource that the script runs
TEMP_DIR = "/corral-repl/tacc/dmc/siva/ICA/temp/"

#Path to FITS executabl
FITS_PATH ="/corral-repl/tacc/dmc/siva/ICA/fits-0.6.1/fits.sh"

IRODS1 = "/tempZone/home/rods/Metaponto/publication/draft/PZ81_1081PL-C_b43_p16_f1_M-1.tif"
put ="PUT"

#ColPath = "/tempZone/home/rods"
#UNIX DELIMITERs
DELIMITER = "/"

##
# Determines if the fileName conforms to the naming convention
def isValidName(fileName):
    
    #Split the filename
    x = fileName.split("_")
    
    #Should have 4 or 5 parts
    if not (len(x) == 5 or len(x) == 6):
        return False
    #if not ( len(x) == 6):
    #  return False
    
    #TODO: Add more logic
    
    
    return True

##
# Executes the iRods icommand iget or irods_path and saves a file to server_path
# Notes:  Will this cause a recursive issue???
def getIRodsFile(irods_path, server_path):
    command = IRODS_ICOMMAND_PATH + DELIMITER + "iget -Q -f " + addParentheses(irods_path.rstrip()) + " " + addParentheses(server_path)
    #print command
    os.system(command)
    return

#Only process on non *.mets.xml and non *.fits.xml files
def shouldProcess(fileName):
    
    #Only process on non *.mets.xml and non *.fits.xml files
    regexMETS = re.compile(".mets.xml")
    regexFITS = re.compile(".fits.xml")
    if not regexMETS.search(fileName) and not regexFITS.search(fileName):
        return 1
    return 0

##
# Surrounds the given string with commas
def addParentheses(string):
    #assert isinstance(string, str), "'string' parameter not of type 'str'!"
    
    return "\"" + string + "\""

## Not required in this code..If you use Java this may be useful
def executeSystemProcess(command_line):
    
    
    #Need to replace '\' with '\\' in Windows environment
    
    args = shlex.split(command_line)#, comments=False, posix=False)
    #print 'args: ' + command_line
    proc = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    stdout, stderr = proc.communicate()
    #result = 'stdout: ' + isNull(stdout, "n/a") + ' stderr: ' + isNull(stderr, "n/a")
    #print result
    #print 'executeSystemProcess() complete!'
    #proc.wait()
    return stdout

#Calculate Collection Path
def calculatecollpath(rods_path):
    stripped1 = rods_path.split("/")
    getLen = len(stripped1) -1
    
    s1 = ""
    
    
    stripped1 = stripped1[1:getLen]
    for s in stripped1:
        #       if s != ''
        s1 += s+"/"
    return DELIMITER+s1.rstrip("/");

#print stripped1


def identifyCollectionPath(rods_path):
    result = isIRodsFileOrDir(rods_path)
    if (result == 'DIR'):
        collectionpath = calculatecollpath(rods_path)
    else:
        collectionpath = '/corralZ/web/ICA'
    #collectionpath = ColPath
    return collectionpath

def isIRodsFileOrDir(irods_path):
    
    
    #We will call imeta to look for a Collection, if the irods_path is NOT a collection, the stdout will contain the string 'does not exist'
    command = IRODS_ICOMMAND_PATH + DELIMITER + "imeta ls -C " + addParentheses(irods_path)
    #print command
    stdout,output = commands.getstatusoutput(command)
    
    
    special_string = 'does not exist'
    
    result = output.find(special_string)
    
    if result == -1:
        return 'DIR'
    else:
        return 'FILE'
#  print 'FILE'

##
##
# Return everything after the last DELIMITER
def getIRodsFileName(irods_path):
    
    #return irods_path
    return irods_path[irods_path.rfind(UNIX_DELIMITER) + 1:]

# Given and irods_path, returns a string representing the physical server path
def getTempServerPath(irods_path):
    fileOrDirName = getIRodsFileName(irods_path)
    
    #return TEMP_DIR +"Metaponto" + DELIMITER +"PZ"+ DELIMITER +  fileOrDirName
    return TEMP_DIR + fileOrDirName


##
# This method takes the input arguments and parses them and passed controll to the appropriate sub methods
def processArguments(argv):
    
    
    
    print argv[1]
    print argv[2] 
    icommand = argv[1].rstrip()
    i = 2
    
    rods_path = argv[2]
    global COLLECTION_PATH
    
    COLLECTION_PATH = identifyCollectionPath(rods_path.rstrip())
    if icommand == 'PUT' or icommand == 'REMOVE':
        
        rods_path = ''
        i = 2
        while i < len(argv):
            rods_path += argv[i]+' ' #Add back the original spacing
            i += 1
        rods_path = rods_path.rstrip()
        
        temp_server_path = getTempServerPath(rods_path)
        
        result = isIRodsFileOrDir(rods_path)
        if (result == 'FILE' and icommand == 'PUT'):
            
            getIRodsFile(rods_path, TEMP_DIR)
            Metaprocess(rods_path, temp_server_path)
            os.remove(temp_server_path)
        elif (result == 'FILE' and icommand == 'REMOVE'):
            processRemove(rods_path, temp_server_path)
        #processPut(irods_path, temp_server_path)
        elif (result == 'DIR' and icommand == 'PUT'):
            
            getIRodsFileRecursive(rods_path, temp_server_path)
            processDirPut(temp_server_path, rods_path)
            
            shutil.rmtree(temp_server_path)

    elif icommand == 'MOVE':
        sourceIRodsPath = ''
        destIRodsPath = ''
        
        #Flags used when calling this script to distinguish the irods_paths
        sourceMark = 'source'
        destMark = 'dest'
        
        i = 2 #The first argument after the sourceMark argument.  Ex. 'script.py MOVE sourceMark pathPart1 pathPart2 pathPart3 destMark pathPart1 pathPart2
        currentArg = argv[i]
        while currentArg != destMark:
            sourceIRodsPath += currentArg + ' ' #Add back the original spacing
            i += 1
            currentArg = argv[i]
        
        #Remove last added space
        sourceIRodsPath = sourceIRodsPath.rstrip()
        
        #Now we h ave the sourceObject, now get destObject
        i += 1 #Skip over destMark
        while i < len(argv):
            destIRodsPath += argv[i] + ' ' #Add back the original spacing
            i += 1
        
        
        #Determine if this file should be processed.  TODO: Not 100% on the implications of this
        if not shouldProcess(sourceIRodsPath):
            return
        processMove(sourceIRodsPath, destIRodsPath)
    #os.remove(TEMP_DIR)
    #   return



    # os.remove(TEMP_DIR)

    return

def processMove(source_irods_path, dest_irods_path):
    
    
    
    source_server_path = getTempServerPath(source_irods_path)
    dest_server_path = getTempServerPath(dest_irods_path).rstrip()
    
    #Are we dealing with a file or directory
    result = isIRodsFileOrDir(dest_irods_path.rstrip())
    
    if result == "FILE":
        
        processRemove(source_irods_path, source_server_path)
        getIRodsFile(dest_irods_path, TEMP_DIR)
        Metaprocess(dest_irods_path.rstrip(), dest_server_path.rstrip(), old_irods_path=source_irods_path.rstrip())
        os.remove(source_server_path)
    elif result == "DIR":
        
        #Iterate through the directory removing .mets.xml files and process other files as a put
        #Need to pull a copy of full directory structure to temp location
        getIRodsFileRecursive(dest_irods_path.rstrip(), TEMP_DIR)
        for subdir, dirs, files in os.walk(dest_server_path):
            for file in files:
                #Replace the source_server_path portion of subdir with new destination
                
                new_subdir = subdir.replace(source_server_path, dest_server_path)
                
                old_server_path = subdir + DELIMITER + file
                new_server_path = new_subdir + DELIMITER + file
                old_server_path = old_server_path.rstrip()
                new_server_path = new_server_path.rstrip()
                #Only process non-mets.xml and non-fits.xml files
                if shouldProcess(file):
                    old_irods_path = old_server_path.replace(source_server_path, source_irods_path)#source_irods_path + UNIX_DELIMITER + subdir + UNIX_DELIMITER + file#getIRodsPath(old_server_path)
                    new_irods_path = new_server_path.replace(dest_server_path, dest_irods_path.rstrip())#dest_irods_path + UNIX_DELIMITER + subdir + UNIX_DELIMITER + file#getIRodsPath(new_server_path)
                    
                    Metaprocess(new_irods_path.rstrip(), new_server_path.rstrip(), old_irods_path=old_irods_path.rstrip())#, old_server_path=old_server_path)
    
        #Remove our temp file or dir
        shutil.rmtree(dest_server_path)
        return
def shouldProcess(fileName):
    
    #Only process on non *.mets.xml and non *.fits.xml files
    regexMETS = re.compile(".mets.xml")
    regexFITS = re.compile(".fits.xml")
    if not regexMETS.search(fileName) and not regexFITS.search(fileName):
        return 1
    return 0

def notFileNameStandard(directory_path):
    categories = directory_path.split("/")
    # print categories
    # print "dsddfsdffdfd"
    # print categories[7]
    #print categories[8]
    categories = categories[0:len(categories)]
    #print categories
    if categories[7] == 'excavation_documentation' and categories[8]== 'field_notes':
        skipparameter = 1
    elif  categories[7] == 'excavation_documentation' and categories[8]== 'contact_sheets':
        skipparameter = 1
    elif categories[7] =='finds' and categories[8]=='bw' and categories[9] =='miscellaneous':
        skipparameter =1
    elif categories[7] =='finds' and categories[8]=='color' and categories[9] =='miscellaneous':
        skipparameter =1
    elif categories[7] =='finds' and categories[8]=='digital':
        skipparameter =1
    elif categories[7] =='finds' and categories[8]=='illustrations_ink':
        skipparameter =1
    elif categories[7] =='finds' and categories[8]=='illustrations_sketch':
        skipparameter =1
    elif categories[7] =='finds' and categories[8]=='mounted_slides':
        skipparameter =1
    elif categories[7] =='finds' and categories[8]=='medium_format' and categories[9] == 'miscellaneous':
        skipparameter =1
    elif categories[7] =='people_places' and categories[8]=='digital':
        skipparameter =1
    elif categories[7] =='people_places' and categories[8]=='mounted_slides':
        skipparameter =1
    elif categories[7] =='site' and categories[8]=='bw' and categories[9] == 'miscellaneous':
        skipparameter =1
    elif categories[7] =='site' and categories[8]=='color' and categories[9] == 'miscellaneous':
        skipparameter =1
    elif categories[7] =='site' and categories[8]=='plans':
        skipparameter =1
    elif categories[7] =='site' and categories[8]=='digital':
        skipparameter =1
    elif categories[7] =='site' and categories[8]=='reconstructions':
        skipparameter =1
    elif categories[7] =='site' and categories[8]=='mounted_slides':
        skipparameter =1
    elif categories[7].rstrip() =='site' and categories[8].rstrip()=='sections':
        skipparameter =1
    elif categories[6] =='publication':
        skipparameter =1
    elif categories[6] =='publication' and categories[7]=='draft':
        skipparameter =1
    elif categories[6] =='publication' and categories[7]=='final':
        skipparameter =1
    elif categories[6] =='specialist_studies':
        skipparameter =1
    else:
        skipparameter = 0

    return skipparameter##
# FITS
# Execute FITS tool and output XML to a file
def FITS(server_path):
    (dirName, fileName) = os.path.split(server_path)
    outputPath = TEMP_DIR + fileName + ".fits.xml"
    command = FITS_PATH + " -i " + addParentheses(server_path) + " -o " + addParentheses(outputPath) #Include commas incase filepath has spaces
    
    #subprocess.call(command)
    #executeSystemProcess(command)
    XMLfile= os.system(command)
    # print XMLfile
    return outputPath

##
# Parse the file name and return the parts conforming to the filenaming convention

def parseFileName(fileName):
    
    stripped = fileName.split(".")[0]
    x = stripped.split('_')
    if len(x) == 6:
        sitecode = x[0]
        objectcode = x[0]+"_"+x[1]
        stagecode = x[2]+"_"+x[3]+"_"+x[4]
        mastervsversion = x[5]
    if len(x) == 5:
        sitecode = x[0]
        objectcode = ""
        stagecode = x[1]+"_"+x[2]+"_"+x[3]
        mastervsversion = x[4]
    
    
    
    
    return (sitecode, objectcode, stagecode, mastervsversion)

##
# Simply add the Title to DC Terms which is the fileName
def parseTitleFileName(fileName):
    
    stripped1 = fileName.split("/")
    getLen = len(stripped1) -1
    return (stripped1[getLen])


##
# Given the server_path, returns a string representing the logical irods_path
def getIRodsPath(server_path, rods_path):
    
    #Strip off the VAULT part of the server_path.  The irods_path will be: zone + remainder
    stripped_server_path = server_path.split(TEMP_DIR)[1] #Get the right portion of the split
    
    
    result1 = isIRodsFileOrDir(rods_path)
    
    
    # else:
    irods_path = COLLECTION_PATH + DELIMITER + stripped_server_path
    return irods_path

##
# Handles the iPut logic for a given file
# First check to see if the file already exists, and remove old file, mets doc, and iCat data if so
# Then create and archive the new metadata
def processPut(irods_path, server_path):
    
    #TODO: Add logic for handling case when file already exists
    
    #Now create and archive new metadata
    Metaprocess(irods_path, server_path)
    
    return

##
# Executes the iRods icommand iget or irods_path and saves a file to server_path
# Notes:  Will this cause a recursive issue???
def getIRodsFileRecursive(irods_path, server_path):
    command = IRODS_ICOMMAND_PATH + DELIMITER + "iget -Q -f -r " + addParentheses(irods_path) + " " + addParentheses(server_path)
    
    
    os.system(command)
    return

##
# Process all files in root/sub directories
# Pass each file to processFile
def processDirPut(server_dir_path, rods_path):
    
    # Verify parameters
    #assert os.path.isdir(server_dir_path), "'server_dir_path' parameters is not a directory!"
    
    for subdir, dirs, files in os.walk(server_dir_path):
        for file in files:
            server_path =  subdir + DELIMITER + file
            
            irods_path = getIRodsPath(server_path, rods_path)
            
            processPut(irods_path, server_path)
    
    return

def compareMvsV(firstword):
    if (firstword == 'M') | (firstword =='m'):
        out = 'm'
    elif (firstword == 'V') | (firstword =='v'):
        out = 'v'
    else:
        out = ""
    return out
##
# FITS 2 METS XSLT
# Read the FITS XML file and convert to METS XML file using XSLT
def applyXML(fits_server_path):
    
    xml_input = etree.parse(fits_server_path)
    xslt_root = etree.parse(stylesheetpath)
    transform = etree.XSLT(xslt_root)
    outputPath = fits_server_path.replace(".fits.xml", ".mets.xml")
    out = open(outputPath, 'w')
    out.write(etree.tostring(transform(xml_input)))
    out.close()
    return outputPath
#print (str(transform(xml_input))("/Users/Siva/xxl.xml",pretty_print=False))


def addObjectIdentifer(directorypath,xpath1,metspath):
    objID = SERVER_URL + directorypath.replace(DELIMITER, "/")
    objectID_XPath = "/mets:mets/mets:amdSec/mets:digiprovMD/mets:mdWrap/mets:xmlData/premis/premis:objectIdentifier"
    addXMLnode(metspath,objectID_XPath,objID,"objectIdentifierValue","info:lc/xmlns/premis-v2")
    contentLocationValue_XPath = "/mets:mets/mets:amdSec/mets:digiprovMD/mets:mdWrap/mets:xmlData/premis/premis:storage/premis:contentLocation"
    addXMLnode(metspath,contentLocationValue_XPath,objID,"contentLocationValue","info:lc/xmlns/premis-v2")


def splitword(words):
    x=list(words)
    return (x)


def clearIRodsMetadata(irods_path):
    
    command = IRODS_ICOMMAND_PATH + DELIMITER + "imeta rmw -d " + addParentheses(irods_path) + " % %"
    
    os.system(command)
    return



##
# Add a new node/value to xml document at a particular locations
# Locates node defined by locationXPath and adds new node inside that node.
def addXMLnode (metspath,xpath1,value,title,nameSpace):
    
    tree = etree.parse(metspath)
    theNamespaces = {'opf' : "http://www.idpf.org/2007/opf",
        'mets' : "http://www.loc.gov/METS/",
        'dcterms' : "http://purl.org/dc/terms/metadata",
        'dc' : "http://purl.org/dc/elements/1.1/",
        'calibre' : "http://calibre.kovidgoyal.net/2009/metadata",
        'premis' :"info:lc/xmlns/premis-v2",
        'unique-identifier' : "calibre_id" }
    dcterms = nameSpace
    find = tree.xpath(xpath1, namespaces = theNamespaces) [0]
    
    newNode = etree.SubElement(find, etree.QName(dcterms, title))
    #newNode = etree.SubElement(find,title)
    newNode.text = value
    
    tree.write(metspath,pretty_print=True)
    return


##
# ADD METADATA 2 iRods
# This function query's the generated XML and creates
# iRods Metacatalog AVU entries and calls the iRods command line tools 'imeta add objName attrKey attrValue [attrUnit]'
# client to register the information
def parseMetadataforIrods(irods_path, metspath):
    #print metspath
    # print irods_path
    clearIRodsMetadata(irods_path)
    tree = etree.parse(metspath)
    theNamespaces = {'opf' : "http://www.idpf.org/2007/opf",
        'mets' : "http://www.loc.gov/METS/",
        'dcterms' : "http://purl.org/dc/terms/metadata",
        'dc' : "http://purl.org/dc/elements/1.1/",
        'calibre' : "http://calibre.kovidgoyal.net/2009/metadata",
        'premis' :"info:lc/xmlns/premis-v2",
        'unique-identifier' : "calibre_id" }
    # xpath = "/mets:mets/mets:dmdSec/mets:mdWrap/mets:xmlData/dcterms:isPartOf"
    xpath = "//{http://purl.org/dc/terms/metadata}temporal"
    
    value = "temporal"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}spatial"
    
    value = "spatial"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}isPartOf"
    
    value = "isPartOf"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    
    xpath = "//{http://purl.org/dc/terms/metadata}type"
    
    value = "type"
    
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}isPartOf"
    
    value = "isPartOf"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}source"
    
    value = "source"
    
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}subject"
    
    value = "subject"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}identifier"
    
    value = "identifier"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)
    xpath = "//{http://purl.org/dc/terms/metadata}hasFormatOf"
    
    value = "hasFormatOf"
    for msg in tree.findall((xpath)%theNamespaces):
        
        
        text = msg.text
        
        if text is None:
            print ''
        else:
            registerIRodsMetadata(irods_path, text, value)

##
# Executes the iRods icommand iput with the given AVU string triple
# Notes:  Will this cause a recursive issue???
def registerIRodsMetadata(irods_path, key, value):
    
    value = value[0: 1050]
    command = IRODS_ICOMMAND_PATH + DELIMITER + "imeta add -d  " + irods_path + " " + value + " " + key
    
    if key == 'description':
        print ''
    os.system(command)
    return
##
# Thie method handles all of the business logic for creating a new METS document for a file
# and registering it with iCAT along with a subset of that metadata
def Metaprocess(irods_path,server_path, old_irods_path=None, old_server_path=None):
    
    Mets_out = server_path + ".mets.xml"
    #clearIRodsMetadata(irods_path)
    #parseMetadataforIrods(path, Mets_out)
    
    fits_input = server_path
    fits_server_path=FITS(fits_input)
    
    metsout=applyXML(fits_server_path)
    fits_irods_path = irods_path + ".fits.xml"
    
    path = irods_path
    
    # fitsOut = fits(fits_input) #Produce fits output, return file path to fits document
    #metsOut = applyXSL(fitsOut) # C
    #addObjectIdentifer(path,xpath1,metsout)
    (dirName, fileName) = os.path.split(server_path)
    directoryParsing(path,xpath,metsout,fileName)
    addObjectIdentifer(path,xpath1,metsout)
    Titleparsing = notFileNameStandard(path)
        
    if (Titleparsing == 0) and (isValidName(fileName)):
            addTitleParsing(fileName,metsout)
    
    
    
    registerIRodsFile(fits_irods_path, fits_server_path)
    parseMetadataforIrods(path, metsout)
    os.remove(fits_server_path)
    #  os.remove(irods_path)
    
    
    #print Mets_out
    mets_irods_path = irods_path + ".mets.xml"
    registerIRodsFile(mets_irods_path, metsout)
    #os.remove(Mets_out)
    os.remove(metsout)
    return
# calls the irods icommand irm for the irods_path given
def removeIRodsFile(irods_path):
    #TODO: Add asserts
    command = IRODS_ICOMMAND_PATH + DELIMITER + "irm " + addParentheses(irods_path)
    #print command
    os.system(command)
    return

def processRemove(irods_path, server_path):
    
    #Get the path to the mets document
    mets_irods_path = irods_path + ".mets.xml"
    removeIRodsFile(mets_irods_path)
    
    #Get the path to the fits document
    fits_irods_path = irods_path + ".fits.xml"
    removeIRodsFile(fits_irods_path)
    
    return

def registerIRodsFile(irods_path, server_path):
    
    command = IRODS_ICOMMAND_PATH + DELIMITER + "iput -f -R " + IRODS_DEFAULT_RESOURCE + " " + addParentheses(server_path) + " " + addParentheses(irods_path)
    #print command
    os.system(command)
    return

def addTitleParsing (filename, metspath):
    (typeCode, objectcode, stageCode, masterVsVersion) = parseFileName(filename)
    xpath = "//mets:dmdSec/mets:mdWrap/mets:xmlData"
    
    Titlefilename = filename
    #parseTitleFileName(filename)
    #Split PZ78 into separate words
    x=splitword(typeCode)
    temporal = x[2]+x[3]
    spatial = x[0]+x[1]
    
    #For TItle sitecode
    # if spatial ="pz"
    typeCode = "Pantanello"
    addXMLnode(metspath,xpath2,typeCode,"spatial","http://purl.org/dc/terms/metadata")
    #For temporal 78
    addXMLnode(metspath,xpath2,temporal,"temporal","http://purl.org/dc/terms/metadata")
    #For Title Objectcode
    addXMLnode(metspath,xpath,Titlefilename,"identifier","http://purl.org/dc/terms/metadata")
    
    #for ObjectCode
    addXMLnode(metspath,xpath,objectcode,"isPartOf","http://purl.org/dc/terms/metadata")
    #For Binder and Page and frame Number
    
    addXMLnode(metspath,xpath,stageCode,"source","http://purl.org/dc/terms/metadata")
    
    #for Master Version
    
    # masterVsVersionMapping = { "m" : "hasFormatOf", "v" : "isVersionOf" }
    # masterVsVersionValue = masterVsVersionMapping.get(masterVsVersion, "Not Found")
    #masterVsVersionEntry = "Master or Version: " + masterVsVersionValue
    wordlist = splitword(masterVsVersion)
    
    if not wordlist != '':
        masterValue = compareMvsV(wordlist[0])
        masterVsVersionMapping = { "m" : "hasFormatOf", "v" : "isVersionOf" }
        masterVsVersionValue = masterVsVersionMapping.get(masterValue, "Not Found")	
        #print masterValue
        addXMLnode(metspath,xpath,masterVsVersion,masterVsVersionValue,"http://purl.org/dc/terms/metadata")
    return
def directoryaddressMapping(irods_path, stripped_server_path):
    
    categoryPath = irods_path.split(COLLECTION_PATH)[1]
    
    stripped_server_path1 = stripped_server_path.split("/")
    length = len(stripped_server_path1)
    
    getstrip = stripped_server_path1[length-1]
    categoryPath1 = categoryPath.split(stripped_server_path)[0]
    
    return categoryPath1 + DELIMITER + getstrip

def directoryParsing (directorypath,xpath, irodspath, fileName):
    
    Collpath = '/corralZ/web/ICA'
    #Collpath = Colpath
    tempPath = directorypath.replace(Collpath, "")
    #tempPath = directorypath.replace(COLLECTION_PATH, "")
    
    #print "tempPath = " + tempPath
    categoriesPath = tempPath.replace(fileName, "")
    #print "categoriesPath = " + categoriesPath
    #Now split categoriesPath into individual parts
    #categories = categoriesPath.split(DELIMITER)
    categories =  categoriesPath.split("/")
    categories = categories[1:len(categories)]
    
    metspath = irodspath
    #fsf
    calendarYearMapping = {  "Metaponto" : "spatial",
        "field" : "isPartOf",
        "PZ" : "spatial",
        "excavation_documentation" : "subject",
        "field_notes" : "type",
        "contact_sheets" : "type",
        "finds" : "subject",
        "miscellaneous" : "subject",
        "color" : "type",
        "digital" :"type",
        "illustrations_ink" : "type",
        "illustrations_sketch" : "type",
        "medium_format" : "type",
        "mounted_slides" : "type",
        "bw" : "type",
        "people_and_places" : "subject",
        "people_places" : "subject",
        "site" : "subject",
        "plans" : "type",
        "reconstructions" : "type",
        "sections" : "type",
        "publication" : "subject",
        "draft" : "type",
        "final" : "type",
        "specialist_studies":"subject",
        "archaic_pottery" : "subject",
        "black_gloss" : "subject",
        "coins":"subject",
        "cookingware": "subject",
        "figuredware":"subject",
        "glassware" : "subject",
        "gnathia" : "subject",
        "lamps" : "subject",
        "late_republican_fineware" : "subject",
        "lithics" : "subject",
        "loomweights" : "subject",
        "metals" :"subject",
        "miniatures" : "subject",
        "mold_vessels" : "subject",
        "plainware_bandedware" :"subject",
        "rooftiles" : "subject",
        "substantial_vessels" : "subject",
        "terracottas" : "subject",
        "amphorae" : "subject",
        "fauna" :"subject",
        "geology" : "subject",
        "geomorphology" : "subject",
        "palaeobotany" : "subject",
        "physical_anthropology" : "subject",
        "GIS" : "subject",
        "cad" : "resourcetype",
        "exports" : "resourcetype",
        "geodatabases" : "resourcetype",
        "layers" : "resourcetype",
        "map_documents" : "resourcetype",
        "remote_sensing" : "resourcetype",
        "scanned_plans" : "resourcetype",
        "shapefiles" : "resourcetype",
        "support_documents" : "resourcetype",
        "surfaces" : "resourcetype",
        "surveys" : "resourcetype",
        "symbols" : "resourcetype",
        "tables" : "resourcetype",
        "assemblage" : "isPartOf",
        
        
        }
    
    #print calendarYear
    #addXMLnode(metspath,xpath," ","coverage","http://purl.org/dc/terms/metadata")
    #if categories[0] == 'Metaponto':
    #print 'siva'# addXMLnode(metspath,xpath," ","coverage","http://purl.org/dc/terms/metadata")
    
    for words in categories:
        #print words
        
        # print xpath
        calendarYear = calendarYearMapping.get(words, "NotFound")
        if words == 'Metaponto':
            addXMLnode(metspath,xpath," ","coverage","http://purl.org/dc/terms/metadata")
            addXMLnode(metspath,xpath2,words,calendarYear,"http://purl.org/dc/terms/metadata")
        if words == 'PZ':
            #addXMLnode(metspath,xpath," ","coverage","http://purl.org/dc/terms/metadata")
            
            addXMLnode(metspath,xpath2,words,calendarYear,"http://purl.org/dc/terms/metadata")
        if words == 'field':
            addXMLnode(metspath,xpath," ","relation","http://purl.org/dc/terms/metadata")
            
            addXMLnode(metspath,xpath3,words,calendarYear,"http://purl.org/dc/terms/metadata")
        if words =='':
            print ''
        elif words !='Metaponto' and words!= 'PZ' and words!= 'field':
            addXMLnode(metspath,xpath,words,calendarYear,"http://purl.org/dc/terms/metadata")
                #print words
                #print 'inside'
                #elif words =='':
                #print 'empty'
        else:
                    print ''
    return


#fits_server_path=FITS(SOURCE_FILE)
#applyXML(fits_server_path)
#addObjectIdentifer(path,xpath1)
#if isValidName(filename):
# addTitleParsing(filename)
#directoryParsing(path,xpath)
#sys.argv = raw_input('Enter command line arguments: ').split()

#def main():
#  processArguments(sys.argv)
# print "prdfsdfa"
#return


def main():
    print "Start Main"
    #init() #Initialize variables
    
    try:
        print sys.argv
        processArguments(sys.argv)
    #print sys.argv
    except:
        exc_type, exc_value, exc_traceback = sys.exc_info()
        print "Error: ", exc_value #Should output to iRods log
    #text = str(traceback.format_exception(exc_type, exc_value, exc_traceback))
    #msg = MIMEText(text, 'plain') #Email body
    #msg['Subject'] = 'ICA iRods Error'
    #msg['From'] = MAIL_FROM
    #msg['To'] = MAIL_TO
    #server = smtplib.SMTP('localhost')
    #server.sendmail(MAIL_FROM, MAIL_TO, msg.as_string())
    #server.quit()
    print "End Main"

    return

## Execute Main
if __name__ == "__main__":
    #dev() #use in development
    main() #use in production
